# 1変数関数の微分
f<-function(x){
  return(x^3) 
}

# 差分メッシュ
h=0.01

# x=1;xの1階微分を計算
(f(1+h)-f(1))/h

# x=1;xの2階微分を計算
(f(1+2*h)-2*f(1+h)+f(1))/(h^2)

# 2変数関数の微分
f=function(x,y){
  return((x^3)*(y^3))
}

# x=1;y=1;
# xの1階微分を計算
(f(1+h,1)-f(1,1))/h

# xの2階微分を計算
(f(1+2*h,1)-2*f(1+h,1)+f(1,1))/(h^2)

# yの1階微分を計算
(f(1,1+h)-f(1,1))/h

# yの2階微分を計算
(f(1,1+2*h)-2*f(1,1+h)+f(1,1))/(h^2)

# x,yの順番に偏微分
(f(1+h,1+h)-f(1+h,1)-f(1,1+h)+f(1,1))/(h^2)

# y,xの順番に偏微分
(f(1+h,1+h)-f(1,1+h)-f(1+h,1)+f(1,1))/(h^2)

# xで2階微分
(f(1+2*h,1)-2*f(1+h,1)+f(1,1))/(h^2)

# yで2階微分
(f(1,1+2*h)-2*f(1,1+h)+f(1,1))/(h^2)
