# 多重積分
# 2重積分（台形公式）

# 積分区間：x軸
x1=0;x2=1

# 積分区間：y軸
y1=1;y2=2

# h、k幅
h=0.25;k=0.5

# 関数定義
f<-function(x,y){
  z=x^2+x*y
  return(z)
}

# Y軸
Y=seq(y1,y2,k)

# X軸
X=seq(x1,x2,h)

lattice1=array(4,dim=c(length(X),length(Y)))
lattice2=array(0,dim=c(length(X),length(Y)))
for(j in 1:length(X)){
  for(i in 1:length(Y)){
    lattice2[j,i]=f(X[j],Y[i])
  }
}

lattice1[,1]=2;lattice1[1,]=2;
lattice1[,ncol(lattice1)]=2;lattice1[nrow(lattice1),]=2
lattice1[1,1]=1;lattice1[nrow(lattice1),ncol(lattice1)]=1;
lattice1[1,ncol(lattice1)]=1;lattice1[nrow(lattice1),1]=1
print(paste0("重積分の値は",sum((1/4)*h*k*lattice1*lattice2)))
