# 関数定義
f<-function(x){
  z=exp(x)
  return(z)
}

# 差分する終点座標を決定
f_points=0.4;start_points=0

# 分割の細かさを決める
sep_f=0.1

# 差分前の元データを作成
f_data=data.frame(x=seq(start_points,f_points,sep_f),f=0)

for(j in 1:nrow(f_data)){
  f_data$f[j]=f(f_data$x[j])
}

# 差文商

# 元データより細かいメッシュを入れる
sep=0.01

# 結果の実際の値と予測値を入れる箱を作る
func_data=data.frame(x=seq(start_points,f_points,sep),f=0)

# 差文商の計算
difference=X=array(0,dim=c(nrow(f_data),nrow(f_data)))
difference[1,]=f_data$f;X[1,]=f_data$x

for(j in 1:(nrow(f_data)-1)){
  k=j+1
  vector=difference[j,]
  vector=vector[1:(length(vector)-(j-1))]
  zeros=rep(0,j)
  d_f=c()

  for(l in 1:(length(vector)-1)){
    d_f=c(d_f,(vector[l+1]-vector[l]))
  }

  d_f=c(d_f,zeros)
  difference[k,]=d_f
}
